/*===========================================================================*/
/*   (Llib/psemaphore.scm)                                                   */
/*   Bigloo (4.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Jan 27 07:55:05 AM CET 2025     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/bin/bigloo -ldopt -L/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/libbacktrace/usr/lib64/bigloo/4.6a  -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -unsafe -safee -copt -fPIC -copt -IPosix Llib/psemaphore.scm -o objs/objs_u/psemaphore.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 0

/* standard Bigloo include */
#include <bigloo.h>
#include <bglpthread.h>

#ifdef __cplusplus
extern "C" {
#endif
#ifndef BGL_MODULE_TYPE_DEFINITIONS
#define BGL_MODULE_TYPE_DEFINITIONS
#ifndef BGL___PTH_SEMAPHORE_TYPE_DEFINITIONS
#define BGL___PTH_SEMAPHORE_TYPE_DEFINITIONS
#endif // BGL___PTH_SEMAPHORE_TYPE_DEFINITIONS
#endif // BGL_MODULE_TYPE_DEFINITIONS

static obj_t BGl_requirezd2initializa7ationz75zz__pth_semaphorez00 = BUNSPEC;
static long BGl_schemezd2ze3modez31zz__pth_semaphorez00(obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62semaphorezd2waitzb0zz__pth_semaphorez00(obj_t, obj_t);
static obj_t BGl_z62deletezd2semaphorezb0zz__pth_semaphorez00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
static obj_t BGl_genericzd2initzd2zz__pth_semaphorez00(void);
static obj_t BGl__openzd2semaphorezd2zz__pth_semaphorez00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__pth_semaphorez00(void);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_semaphorezd2waitzd2zz__pth_semaphorez00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__pth_semaphorez00(void);
BGL_EXPORTED_DECL obj_t BGl_closezd2semaphorezd2zz__pth_semaphorez00(obj_t);
static obj_t BGl_z62closezd2semaphorezb0zz__pth_semaphorez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_openzd2semaphorezd2zz__pth_semaphorez00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_semaphorezd2trywaitzd2zz__pth_semaphorez00(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__pth_semaphorez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62semaphorezd2postzb0zz__pth_semaphorez00(obj_t, obj_t);
extern obj_t bgl_open_semaphore(obj_t, bool_t, bool_t, long, long);
static obj_t BGl_cnstzd2initzd2zz__pth_semaphorez00(void);
static obj_t BGl_libraryzd2moduleszd2initz00zz__pth_semaphorez00(void);
static obj_t BGl_gczd2rootszd2initz00zz__pth_semaphorez00(void);
static obj_t BGl_z62semaphorezd2trywaitzb0zz__pth_semaphorez00(obj_t, obj_t);
extern int bgl_semaphore_value(obj_t);
static obj_t BGl_search1018ze70ze7zz__pth_semaphorez00(long, obj_t, obj_t, long);
BGL_EXPORTED_DECL long BGl_semaphorezd2valuezd2zz__pth_semaphorez00(obj_t);
static obj_t BGl_z62semaphorezd2valuezb0zz__pth_semaphorez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_semaphorezd2postzd2zz__pth_semaphorez00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_deletezd2semaphorezd2zz__pth_semaphorez00(obj_t);
static obj_t __cnst[ 19 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_semaphorezd2waitzd2envz00zz__pth_semaphorez00, BgL_bgl_za762semaphoreza7d2w1126z00, BGl_z62semaphorezd2waitzb0zz__pth_semaphorez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_closezd2semaphorezd2envz00zz__pth_semaphorez00, BgL_bgl_za762closeza7d2semap1127z00, BGl_z62closezd2semaphorezb0zz__pth_semaphorez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_deletezd2semaphorezd2envz00zz__pth_semaphorez00, BgL_bgl_za762deleteza7d2sema1128z00, BGl_z62deletezd2semaphorezb0zz__pth_semaphorez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_semaphorezd2valuezd2envz00zz__pth_semaphorez00, BgL_bgl_za762semaphoreza7d2v1129z00, BGl_z62semaphorezd2valuezb0zz__pth_semaphorez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_semaphorezd2postzd2envz00zz__pth_semaphorez00, BgL_bgl_za762semaphoreza7d2p1130z00, BGl_z62semaphorezd2postzb0zz__pth_semaphorez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_openzd2semaphorezd2envz00zz__pth_semaphorez00, BgL_bgl__openza7d2semaphor1131za7, opt_generic_entry, BGl__openzd2semaphorezd2zz__pth_semaphorez00, BFALSE, -1 );
DEFINE_STRING( BGl_string1107z00zz__pth_semaphorez00, BgL_bgl_string1107za700za7za7_1132za7, "/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/api/pthread/src/Llib/psemaphore.scm", 87 );
DEFINE_STRING( BGl_string1108z00zz__pth_semaphorez00, BgL_bgl_string1108za700za7za7_1133za7, "_open-semaphore", 15 );
DEFINE_STRING( BGl_string1109z00zz__pth_semaphorez00, BgL_bgl_string1109za700za7za7_1134za7, "vector", 6 );
DEFINE_STRING( BGl_string1110z00zz__pth_semaphorez00, BgL_bgl_string1110za700za7za7_1135za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string1111z00zz__pth_semaphorez00, BgL_bgl_string1111za700za7za7_1136za7, "bint", 4 );
DEFINE_STRING( BGl_string1112z00zz__pth_semaphorez00, BgL_bgl_string1112za700za7za7_1137za7, "bstring", 7 );
DEFINE_STRING( BGl_string1113z00zz__pth_semaphorez00, BgL_bgl_string1113za700za7za7_1138za7, "wrong number of arguments: [1..5] expected, provided", 52 );
DEFINE_STRING( BGl_string1114z00zz__pth_semaphorez00, BgL_bgl_string1114za700za7za7_1139za7, "open-semaphore", 14 );
DEFINE_STRING( BGl_string1115z00zz__pth_semaphorez00, BgL_bgl_string1115za700za7za7_1140za7, "unknown mode", 12 );
DEFINE_STRING( BGl_string1116z00zz__pth_semaphorez00, BgL_bgl_string1116za700za7za7_1141za7, "illegal mode", 12 );
DEFINE_STRING( BGl_string1117z00zz__pth_semaphorez00, BgL_bgl_string1117za700za7za7_1142za7, "&close-semaphore", 16 );
DEFINE_STRING( BGl_string1118z00zz__pth_semaphorez00, BgL_bgl_string1118za700za7za7_1143za7, "semaphore", 9 );
DEFINE_STRING( BGl_string1119z00zz__pth_semaphorez00, BgL_bgl_string1119za700za7za7_1144za7, "&delete-semaphore", 17 );
DEFINE_STRING( BGl_string1120z00zz__pth_semaphorez00, BgL_bgl_string1120za700za7za7_1145za7, "&semaphore-wait", 15 );
DEFINE_STRING( BGl_string1121z00zz__pth_semaphorez00, BgL_bgl_string1121za700za7za7_1146za7, "&semaphore-trywait", 18 );
DEFINE_STRING( BGl_string1122z00zz__pth_semaphorez00, BgL_bgl_string1122za700za7za7_1147za7, "&semaphore-value", 16 );
DEFINE_STRING( BGl_string1123z00zz__pth_semaphorez00, BgL_bgl_string1123za700za7za7_1148za7, "&semaphore-post", 15 );
DEFINE_STRING( BGl_string1124z00zz__pth_semaphorez00, BgL_bgl_string1124za700za7za7_1149za7, "S_IXOTH S_IWOTH S_IROTH S_IRWXO S_IXGRP S_IWGRP S_IRGRP S_IRWXG S_IXUSR S_IWUSR S_IRUSR S_IRWXU :value :mode :excl :create open-semaphore (:create :excl :mode :value) (S_IRUSR S_IWUSR S_IXUSR S_IRGRP S_IWGRP S_IROTH S_IWOTH) ", 225 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_semaphorezd2trywaitzd2envz00zz__pth_semaphorez00, BgL_bgl_za762semaphoreza7d2t1150z00, BGl_z62semaphorezd2trywaitzb0zz__pth_semaphorez00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__pth_semaphorez00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__pth_semaphorez00(long BgL_checksumz00_226, char * BgL_fromz00_227)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__pth_semaphorez00))
{ 
BGl_requirezd2initializa7ationz75zz__pth_semaphorez00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__pth_semaphorez00(); 
BGl_libraryzd2moduleszd2initz00zz__pth_semaphorez00(); 
BGl_cnstzd2initzd2zz__pth_semaphorez00(); 
return 
BGl_methodzd2initzd2zz__pth_semaphorez00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__pth_semaphorez00(void)
{
{ /* Llib/psemaphore.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__readerz00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__bitz00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(0L, "__pth_semaphore"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(0L, "__pth_semaphore"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__pth_semaphorez00(void)
{
{ /* Llib/psemaphore.scm 15 */
{ /* Llib/psemaphore.scm 15 */
 obj_t BgL_cportz00_215;
{ /* Llib/psemaphore.scm 15 */
 obj_t BgL_stringz00_222;
BgL_stringz00_222 = BGl_string1124z00zz__pth_semaphorez00; 
{ /* Llib/psemaphore.scm 15 */
 obj_t BgL_startz00_223;
BgL_startz00_223 = 
BINT(0L); 
{ /* Llib/psemaphore.scm 15 */
 obj_t BgL_endz00_224;
BgL_endz00_224 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_222))); 
{ /* Llib/psemaphore.scm 15 */

BgL_cportz00_215 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_222, BgL_startz00_223, BgL_endz00_224); } } } } 
{ 
 long BgL_iz00_216;
BgL_iz00_216 = 18L; 
BgL_loopz00_217:
if(
(BgL_iz00_216==(-1L)))
{ /* Llib/psemaphore.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/psemaphore.scm 15 */
{ /* Llib/psemaphore.scm 15 */
 obj_t BgL_arg1125z00_218;
{ /* Llib/psemaphore.scm 15 */

{ /* Llib/psemaphore.scm 15 */
 obj_t BgL_locationz00_220;
BgL_locationz00_220 = 
BBOOL(((bool_t)0)); 
{ /* Llib/psemaphore.scm 15 */

BgL_arg1125z00_218 = 
BGl_readz00zz__readerz00(BgL_cportz00_215, BgL_locationz00_220); } } } 
{ /* Llib/psemaphore.scm 15 */
 int BgL_tmpz00_253;
BgL_tmpz00_253 = 
(int)(BgL_iz00_216); 
CNST_TABLE_SET(BgL_tmpz00_253, BgL_arg1125z00_218); } } 
{ /* Llib/psemaphore.scm 15 */
 int BgL_auxz00_221;
BgL_auxz00_221 = 
(int)(
(BgL_iz00_216-1L)); 
{ 
 long BgL_iz00_258;
BgL_iz00_258 = 
(long)(BgL_auxz00_221); 
BgL_iz00_216 = BgL_iz00_258; 
goto BgL_loopz00_217;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__pth_semaphorez00(void)
{
{ /* Llib/psemaphore.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* _open-semaphore */
obj_t BGl__openzd2semaphorezd2zz__pth_semaphorez00(obj_t BgL_env1016z00_9, obj_t BgL_opt1015z00_8)
{
{ /* Llib/psemaphore.scm 36 */
{ /* Llib/psemaphore.scm 36 */
 long BgL_l1017z00_26;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_vectorz00_94;
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_vectorz00_94 = BgL_opt1015z00_8; }  else 
{ 
 obj_t BgL_auxz00_263;
BgL_auxz00_263 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_263,BFALSE,BFALSE);} 
BgL_l1017z00_26 = 
VECTOR_LENGTH(BgL_vectorz00_94); } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_g1025z00_30;
{ 
 obj_t BgL_auxz00_268;
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_auxz00_268 = BgL_opt1015z00_8
; }  else 
{ 
 obj_t BgL_auxz00_271;
BgL_auxz00_271 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_271,BFALSE,BFALSE);} 
BgL_g1025z00_30 = 
VECTOR_REF(BgL_auxz00_268,0L); } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_createz00_31;
BgL_createz00_31 = BTRUE; 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_exclz00_32;
BgL_exclz00_32 = BFALSE; 
{ /* Llib/psemaphore.scm 38 */
 obj_t BgL_modez00_33;
BgL_modez00_33 = 
((obj_t)
CNST_TABLE_REF(0)); 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_valuez00_34;
BgL_valuez00_34 = 
BINT(1L); 
{ /* Llib/psemaphore.scm 36 */

{ 
 long BgL_iz00_35;
BgL_iz00_35 = 1L; 
BgL_check1019z00_36:
if(
(BgL_iz00_35==BgL_l1017z00_26))
{ /* Llib/psemaphore.scm 36 */BNIL; }  else 
{ /* Llib/psemaphore.scm 36 */
 bool_t BgL_test1156z00_281;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_arg1035z00_42;
BgL_arg1035z00_42 = 
VECTOR_REF(
((obj_t)BgL_opt1015z00_8),BgL_iz00_35); 
BgL_test1156z00_281 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1035z00_42, 
((obj_t)
CNST_TABLE_REF(1)))); } 
if(BgL_test1156z00_281)
{ 
 long BgL_iz00_288;
BgL_iz00_288 = 
(BgL_iz00_35+2L); 
BgL_iz00_35 = BgL_iz00_288; 
goto BgL_check1019z00_36;}  else 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_arg1034z00_41;
BgL_arg1034z00_41 = 
VECTOR_REF(
((obj_t)BgL_opt1015z00_8),BgL_iz00_35); 
BGl_errorz00zz__errorz00(
((obj_t)
CNST_TABLE_REF(2)), BGl_string1110z00zz__pth_semaphorez00, BgL_arg1034z00_41); } } } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_index1021z00_43;
BgL_index1021z00_43 = 
BGl_search1018ze70ze7zz__pth_semaphorez00(BgL_l1017z00_26, BgL_opt1015z00_8, 
((obj_t)
CNST_TABLE_REF(3)), 1L); 
{ /* Llib/psemaphore.scm 36 */
 bool_t BgL_test1157z00_298;
{ /* Llib/psemaphore.scm 36 */
 long BgL_n1z00_109;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_299;
if(
INTEGERP(BgL_index1021z00_43))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_299 = BgL_index1021z00_43
; }  else 
{ 
 obj_t BgL_auxz00_302;
BgL_auxz00_302 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1021z00_43); 
FAILURE(BgL_auxz00_302,BFALSE,BFALSE);} 
BgL_n1z00_109 = 
(long)CINT(BgL_tmpz00_299); } 
BgL_test1157z00_298 = 
(BgL_n1z00_109>=0L); } 
if(BgL_test1157z00_298)
{ 
 long BgL_auxz00_315; obj_t BgL_auxz00_308;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_316;
if(
INTEGERP(BgL_index1021z00_43))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_316 = BgL_index1021z00_43
; }  else 
{ 
 obj_t BgL_auxz00_319;
BgL_auxz00_319 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1021z00_43); 
FAILURE(BgL_auxz00_319,BFALSE,BFALSE);} 
BgL_auxz00_315 = 
(long)CINT(BgL_tmpz00_316); } 
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_auxz00_308 = BgL_opt1015z00_8
; }  else 
{ 
 obj_t BgL_auxz00_311;
BgL_auxz00_311 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_311,BFALSE,BFALSE);} 
BgL_createz00_31 = 
VECTOR_REF(BgL_auxz00_308,BgL_auxz00_315); }  else 
{ /* Llib/psemaphore.scm 36 */BFALSE; } } } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_index1022z00_45;
BgL_index1022z00_45 = 
BGl_search1018ze70ze7zz__pth_semaphorez00(BgL_l1017z00_26, BgL_opt1015z00_8, 
((obj_t)
CNST_TABLE_REF(4)), 1L); 
{ /* Llib/psemaphore.scm 36 */
 bool_t BgL_test1161z00_328;
{ /* Llib/psemaphore.scm 36 */
 long BgL_n1z00_110;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_329;
if(
INTEGERP(BgL_index1022z00_45))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_329 = BgL_index1022z00_45
; }  else 
{ 
 obj_t BgL_auxz00_332;
BgL_auxz00_332 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1022z00_45); 
FAILURE(BgL_auxz00_332,BFALSE,BFALSE);} 
BgL_n1z00_110 = 
(long)CINT(BgL_tmpz00_329); } 
BgL_test1161z00_328 = 
(BgL_n1z00_110>=0L); } 
if(BgL_test1161z00_328)
{ 
 long BgL_auxz00_345; obj_t BgL_auxz00_338;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_346;
if(
INTEGERP(BgL_index1022z00_45))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_346 = BgL_index1022z00_45
; }  else 
{ 
 obj_t BgL_auxz00_349;
BgL_auxz00_349 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1022z00_45); 
FAILURE(BgL_auxz00_349,BFALSE,BFALSE);} 
BgL_auxz00_345 = 
(long)CINT(BgL_tmpz00_346); } 
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_auxz00_338 = BgL_opt1015z00_8
; }  else 
{ 
 obj_t BgL_auxz00_341;
BgL_auxz00_341 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_341,BFALSE,BFALSE);} 
BgL_exclz00_32 = 
VECTOR_REF(BgL_auxz00_338,BgL_auxz00_345); }  else 
{ /* Llib/psemaphore.scm 36 */BFALSE; } } } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_index1023z00_47;
BgL_index1023z00_47 = 
BGl_search1018ze70ze7zz__pth_semaphorez00(BgL_l1017z00_26, BgL_opt1015z00_8, 
((obj_t)
CNST_TABLE_REF(5)), 1L); 
{ /* Llib/psemaphore.scm 36 */
 bool_t BgL_test1165z00_358;
{ /* Llib/psemaphore.scm 36 */
 long BgL_n1z00_111;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_359;
if(
INTEGERP(BgL_index1023z00_47))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_359 = BgL_index1023z00_47
; }  else 
{ 
 obj_t BgL_auxz00_362;
BgL_auxz00_362 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1023z00_47); 
FAILURE(BgL_auxz00_362,BFALSE,BFALSE);} 
BgL_n1z00_111 = 
(long)CINT(BgL_tmpz00_359); } 
BgL_test1165z00_358 = 
(BgL_n1z00_111>=0L); } 
if(BgL_test1165z00_358)
{ 
 long BgL_auxz00_375; obj_t BgL_auxz00_368;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_376;
if(
INTEGERP(BgL_index1023z00_47))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_376 = BgL_index1023z00_47
; }  else 
{ 
 obj_t BgL_auxz00_379;
BgL_auxz00_379 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1023z00_47); 
FAILURE(BgL_auxz00_379,BFALSE,BFALSE);} 
BgL_auxz00_375 = 
(long)CINT(BgL_tmpz00_376); } 
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_auxz00_368 = BgL_opt1015z00_8
; }  else 
{ 
 obj_t BgL_auxz00_371;
BgL_auxz00_371 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_371,BFALSE,BFALSE);} 
BgL_modez00_33 = 
VECTOR_REF(BgL_auxz00_368,BgL_auxz00_375); }  else 
{ /* Llib/psemaphore.scm 36 */BFALSE; } } } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_index1024z00_49;
BgL_index1024z00_49 = 
BGl_search1018ze70ze7zz__pth_semaphorez00(BgL_l1017z00_26, BgL_opt1015z00_8, 
((obj_t)
CNST_TABLE_REF(6)), 1L); 
{ /* Llib/psemaphore.scm 36 */
 bool_t BgL_test1169z00_388;
{ /* Llib/psemaphore.scm 36 */
 long BgL_n1z00_112;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_389;
if(
INTEGERP(BgL_index1024z00_49))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_389 = BgL_index1024z00_49
; }  else 
{ 
 obj_t BgL_auxz00_392;
BgL_auxz00_392 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1024z00_49); 
FAILURE(BgL_auxz00_392,BFALSE,BFALSE);} 
BgL_n1z00_112 = 
(long)CINT(BgL_tmpz00_389); } 
BgL_test1169z00_388 = 
(BgL_n1z00_112>=0L); } 
if(BgL_test1169z00_388)
{ 
 long BgL_auxz00_405; obj_t BgL_auxz00_398;
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_tmpz00_406;
if(
INTEGERP(BgL_index1024z00_49))
{ /* Llib/psemaphore.scm 36 */
BgL_tmpz00_406 = BgL_index1024z00_49
; }  else 
{ 
 obj_t BgL_auxz00_409;
BgL_auxz00_409 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_index1024z00_49); 
FAILURE(BgL_auxz00_409,BFALSE,BFALSE);} 
BgL_auxz00_405 = 
(long)CINT(BgL_tmpz00_406); } 
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_auxz00_398 = BgL_opt1015z00_8
; }  else 
{ 
 obj_t BgL_auxz00_401;
BgL_auxz00_401 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_401,BFALSE,BFALSE);} 
BgL_valuez00_34 = 
VECTOR_REF(BgL_auxz00_398,BgL_auxz00_405); }  else 
{ /* Llib/psemaphore.scm 36 */BFALSE; } } } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_arg1040z00_51;
{ 
 obj_t BgL_auxz00_415;
if(
VECTORP(BgL_opt1015z00_8))
{ /* Llib/psemaphore.scm 36 */
BgL_auxz00_415 = BgL_opt1015z00_8
; }  else 
{ 
 obj_t BgL_auxz00_418;
BgL_auxz00_418 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1109z00zz__pth_semaphorez00, BgL_opt1015z00_8); 
FAILURE(BgL_auxz00_418,BFALSE,BFALSE);} 
BgL_arg1040z00_51 = 
VECTOR_REF(BgL_auxz00_415,0L); } 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_createz00_52;
BgL_createz00_52 = BgL_createz00_31; 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_exclz00_53;
BgL_exclz00_53 = BgL_exclz00_32; 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_modez00_54;
BgL_modez00_54 = BgL_modez00_33; 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_valuez00_55;
BgL_valuez00_55 = BgL_valuez00_34; 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_namez00_113;
if(
STRINGP(BgL_arg1040z00_51))
{ /* Llib/psemaphore.scm 36 */
BgL_namez00_113 = BgL_arg1040z00_51; }  else 
{ 
 obj_t BgL_auxz00_425;
BgL_auxz00_425 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1724L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1112z00zz__pth_semaphorez00, BgL_arg1040z00_51); 
FAILURE(BgL_auxz00_425,BFALSE,BFALSE);} 
{ /* Llib/psemaphore.scm 40 */
 long BgL_arg1047z00_114;
BgL_arg1047z00_114 = 
BGl_schemezd2ze3modez31zz__pth_semaphorez00(BgL_modez00_54); 
{ /* Llib/psemaphore.scm 40 */
 long BgL_tmpz00_430;
{ /* Llib/psemaphore.scm 40 */
 obj_t BgL_tmpz00_433;
if(
INTEGERP(BgL_valuez00_55))
{ /* Llib/psemaphore.scm 40 */
BgL_tmpz00_433 = BgL_valuez00_55
; }  else 
{ 
 obj_t BgL_auxz00_436;
BgL_auxz00_436 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(1937L), BGl_string1108z00zz__pth_semaphorez00, BGl_string1111z00zz__pth_semaphorez00, BgL_valuez00_55); 
FAILURE(BgL_auxz00_436,BFALSE,BFALSE);} 
BgL_tmpz00_430 = 
(long)CINT(BgL_tmpz00_433); } 
return 
bgl_open_semaphore(BgL_namez00_113, 
CBOOL(BgL_createz00_52), 
CBOOL(BgL_exclz00_53), BgL_arg1047z00_114, BgL_tmpz00_430);} } } } } } } } } } } } } } } } 

}



/* search1018~0 */
obj_t BGl_search1018ze70ze7zz__pth_semaphorez00(long BgL_l1017z00_177, obj_t BgL_opt1015z00_176, obj_t BgL_k1z00_27, long BgL_iz00_28)
{
{ /* Llib/psemaphore.scm 36 */
BGl_search1018ze70ze7zz__pth_semaphorez00:
if(
(BgL_iz00_28==BgL_l1017z00_177))
{ /* Llib/psemaphore.scm 36 */
return 
BINT((-1L));}  else 
{ /* Llib/psemaphore.scm 36 */
if(
(BgL_iz00_28==
(BgL_l1017z00_177-1L)))
{ /* Llib/psemaphore.scm 36 */
return 
BGl_errorz00zz__errorz00(
((obj_t)
CNST_TABLE_REF(2)), BGl_string1113z00zz__pth_semaphorez00, 
BINT(
VECTOR_LENGTH(BgL_opt1015z00_176)));}  else 
{ /* Llib/psemaphore.scm 36 */
 obj_t BgL_vz00_60;
BgL_vz00_60 = 
VECTOR_REF(BgL_opt1015z00_176,BgL_iz00_28); 
if(
(BgL_vz00_60==BgL_k1z00_27))
{ /* Llib/psemaphore.scm 36 */
return 
BINT(
(BgL_iz00_28+1L));}  else 
{ 
 long BgL_iz00_458;
BgL_iz00_458 = 
(BgL_iz00_28+2L); 
BgL_iz00_28 = BgL_iz00_458; 
goto BGl_search1018ze70ze7zz__pth_semaphorez00;} } } } 

}



/* open-semaphore */
BGL_EXPORTED_DEF obj_t BGl_openzd2semaphorezd2zz__pth_semaphorez00(obj_t BgL_namez00_3, obj_t BgL_createz00_4, obj_t BgL_exclz00_5, obj_t BgL_modez00_6, obj_t BgL_valuez00_7)
{
{ /* Llib/psemaphore.scm 36 */
return 
bgl_open_semaphore(BgL_namez00_3, 
CBOOL(BgL_createz00_4), 
CBOOL(BgL_exclz00_5), 
BGl_schemezd2ze3modez31zz__pth_semaphorez00(BgL_modez00_6), 
(long)CINT(BgL_valuez00_7));} 

}



/* scheme->mode */
long BGl_schemezd2ze3modez31zz__pth_semaphorez00(obj_t BgL_modez00_10)
{
{ /* Llib/psemaphore.scm 45 */
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_modez00_10))
{ /* Llib/psemaphore.scm 47 */
return 
(long)CINT(BgL_modez00_10);}  else 
{ /* Llib/psemaphore.scm 47 */
if(
PAIRP(BgL_modez00_10))
{ /* Llib/psemaphore.scm 50 */
 long BgL_resz00_66;
BgL_resz00_66 = 0L; 
{ 
 obj_t BgL_l1013z00_68;
BgL_l1013z00_68 = BgL_modez00_10; 
BgL_zc3z04anonymousza31050ze3z87_69:
if(
PAIRP(BgL_l1013z00_68))
{ /* Llib/psemaphore.scm 53 */
{ /* Llib/psemaphore.scm 54 */
 obj_t BgL_mz00_71;
BgL_mz00_71 = 
CAR(BgL_l1013z00_68); 
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(7))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IRWXU); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(8))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IRUSR); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(9))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IWUSR); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(10))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IXUSR); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(11))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IRWXG); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(12))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IRGRP); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(13))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IWGRP); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(14))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IXGRP); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(15))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IRWXO); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(16))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IROTH); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(17))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IWOTH); }  else 
{ /* Llib/psemaphore.scm 54 */
if(
(BgL_mz00_71==
((obj_t)
CNST_TABLE_REF(18))))
{ /* Llib/psemaphore.scm 54 */
BgL_resz00_66 = 
(BgL_resz00_66 | S_IXOTH); }  else 
{ /* Llib/psemaphore.scm 54 */
BGl_errorz00zz__errorz00(BGl_string1114z00zz__pth_semaphorez00, BGl_string1115z00zz__pth_semaphorez00, BgL_mz00_71); } } } } } } } } } } } } } 
{ 
 obj_t BgL_l1013z00_534;
BgL_l1013z00_534 = 
CDR(BgL_l1013z00_68); 
BgL_l1013z00_68 = BgL_l1013z00_534; 
goto BgL_zc3z04anonymousza31050ze3z87_69;} }  else 
{ /* Llib/psemaphore.scm 53 */((bool_t)1); } } 
return BgL_resz00_66;}  else 
{ /* Llib/psemaphore.scm 49 */
return 
(long)CINT(
BGl_errorz00zz__errorz00(BGl_string1114z00zz__pth_semaphorez00, BGl_string1116z00zz__pth_semaphorez00, BgL_modez00_10));} } } 

}



/* close-semaphore */
BGL_EXPORTED_DEF obj_t BGl_closezd2semaphorezd2zz__pth_semaphorez00(obj_t BgL_sz00_11)
{
{ /* Llib/psemaphore.scm 78 */
{ /* Llib/psemaphore.scm 79 */
 int BgL_arg1065z00_154;
BgL_arg1065z00_154 = 
BGL_SEMAPHORE_CLOSE(BgL_sz00_11); 
return 
BBOOL(
(
(long)(BgL_arg1065z00_154)==0L));} } 

}



/* &close-semaphore */
obj_t BGl_z62closezd2semaphorezb0zz__pth_semaphorez00(obj_t BgL_envz00_164, obj_t BgL_sz00_165)
{
{ /* Llib/psemaphore.scm 78 */
{ /* Llib/psemaphore.scm 79 */
 obj_t BgL_auxz00_542;
if(
BGL_SEMAPHOREP(BgL_sz00_165))
{ /* Llib/psemaphore.scm 79 */
BgL_auxz00_542 = BgL_sz00_165
; }  else 
{ 
 obj_t BgL_auxz00_545;
BgL_auxz00_545 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(3464L), BGl_string1117z00zz__pth_semaphorez00, BGl_string1118z00zz__pth_semaphorez00, BgL_sz00_165); 
FAILURE(BgL_auxz00_545,BFALSE,BFALSE);} 
return 
BGl_closezd2semaphorezd2zz__pth_semaphorez00(BgL_auxz00_542);} } 

}



/* delete-semaphore */
BGL_EXPORTED_DEF obj_t BGl_deletezd2semaphorezd2zz__pth_semaphorez00(obj_t BgL_nz00_12)
{
{ /* Llib/psemaphore.scm 84 */
{ /* Llib/psemaphore.scm 85 */
 int BgL_arg1066z00_156;
{ /* Llib/psemaphore.scm 85 */
 char * BgL_tmpz00_550;
BgL_tmpz00_550 = 
BSTRING_TO_STRING(BgL_nz00_12); 
BgL_arg1066z00_156 = 
BGL_SEMAPHORE_DELETE(BgL_tmpz00_550); } 
return 
BBOOL(
(
(long)(BgL_arg1066z00_156)==0L));} } 

}



/* &delete-semaphore */
obj_t BGl_z62deletezd2semaphorezb0zz__pth_semaphorez00(obj_t BgL_envz00_166, obj_t BgL_nz00_167)
{
{ /* Llib/psemaphore.scm 84 */
{ /* Llib/psemaphore.scm 85 */
 obj_t BgL_auxz00_556;
if(
STRINGP(BgL_nz00_167))
{ /* Llib/psemaphore.scm 85 */
BgL_auxz00_556 = BgL_nz00_167
; }  else 
{ 
 obj_t BgL_auxz00_559;
BgL_auxz00_559 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(3759L), BGl_string1119z00zz__pth_semaphorez00, BGl_string1112z00zz__pth_semaphorez00, BgL_nz00_167); 
FAILURE(BgL_auxz00_559,BFALSE,BFALSE);} 
return 
BGl_deletezd2semaphorezd2zz__pth_semaphorez00(BgL_auxz00_556);} } 

}



/* semaphore-wait */
BGL_EXPORTED_DEF obj_t BGl_semaphorezd2waitzd2zz__pth_semaphorez00(obj_t BgL_sz00_13)
{
{ /* Llib/psemaphore.scm 90 */
{ /* Llib/psemaphore.scm 91 */
 int BgL_arg1067z00_158;
BgL_arg1067z00_158 = 
BGL_SEMAPHORE_WAIT(BgL_sz00_13); 
return 
BBOOL(
(
(long)(BgL_arg1067z00_158)==0L));} } 

}



/* &semaphore-wait */
obj_t BGl_z62semaphorezd2waitzb0zz__pth_semaphorez00(obj_t BgL_envz00_168, obj_t BgL_sz00_169)
{
{ /* Llib/psemaphore.scm 90 */
{ /* Llib/psemaphore.scm 91 */
 obj_t BgL_auxz00_568;
if(
BGL_SEMAPHOREP(BgL_sz00_169))
{ /* Llib/psemaphore.scm 91 */
BgL_auxz00_568 = BgL_sz00_169
; }  else 
{ 
 obj_t BgL_auxz00_571;
BgL_auxz00_571 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(4055L), BGl_string1120z00zz__pth_semaphorez00, BGl_string1118z00zz__pth_semaphorez00, BgL_sz00_169); 
FAILURE(BgL_auxz00_571,BFALSE,BFALSE);} 
return 
BGl_semaphorezd2waitzd2zz__pth_semaphorez00(BgL_auxz00_568);} } 

}



/* semaphore-trywait */
BGL_EXPORTED_DEF obj_t BGl_semaphorezd2trywaitzd2zz__pth_semaphorez00(obj_t BgL_sz00_14)
{
{ /* Llib/psemaphore.scm 101 */
{ /* Llib/psemaphore.scm 102 */
 int BgL_arg1068z00_160;
BgL_arg1068z00_160 = 
BGL_SEMAPHORE_TRYWAIT(BgL_sz00_14); 
return 
BBOOL(
(
(long)(BgL_arg1068z00_160)==0L));} } 

}



/* &semaphore-trywait */
obj_t BGl_z62semaphorezd2trywaitzb0zz__pth_semaphorez00(obj_t BgL_envz00_170, obj_t BgL_sz00_171)
{
{ /* Llib/psemaphore.scm 101 */
{ /* Llib/psemaphore.scm 102 */
 obj_t BgL_auxz00_580;
if(
BGL_SEMAPHOREP(BgL_sz00_171))
{ /* Llib/psemaphore.scm 102 */
BgL_auxz00_580 = BgL_sz00_171
; }  else 
{ 
 obj_t BgL_auxz00_583;
BgL_auxz00_583 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(4649L), BGl_string1121z00zz__pth_semaphorez00, BGl_string1118z00zz__pth_semaphorez00, BgL_sz00_171); 
FAILURE(BgL_auxz00_583,BFALSE,BFALSE);} 
return 
BGl_semaphorezd2trywaitzd2zz__pth_semaphorez00(BgL_auxz00_580);} } 

}



/* semaphore-value */
BGL_EXPORTED_DEF long BGl_semaphorezd2valuezd2zz__pth_semaphorez00(obj_t BgL_sz00_15)
{
{ /* Llib/psemaphore.scm 107 */
return 
(long)(
bgl_semaphore_value(BgL_sz00_15));} 

}



/* &semaphore-value */
obj_t BGl_z62semaphorezd2valuezb0zz__pth_semaphorez00(obj_t BgL_envz00_172, obj_t BgL_sz00_173)
{
{ /* Llib/psemaphore.scm 107 */
{ /* Llib/psemaphore.scm 108 */
 long BgL_tmpz00_590;
{ /* Llib/psemaphore.scm 108 */
 obj_t BgL_auxz00_591;
if(
BGL_SEMAPHOREP(BgL_sz00_173))
{ /* Llib/psemaphore.scm 108 */
BgL_auxz00_591 = BgL_sz00_173
; }  else 
{ 
 obj_t BgL_auxz00_594;
BgL_auxz00_594 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(4942L), BGl_string1122z00zz__pth_semaphorez00, BGl_string1118z00zz__pth_semaphorez00, BgL_sz00_173); 
FAILURE(BgL_auxz00_594,BFALSE,BFALSE);} 
BgL_tmpz00_590 = 
BGl_semaphorezd2valuezd2zz__pth_semaphorez00(BgL_auxz00_591); } 
return 
BINT(BgL_tmpz00_590);} } 

}



/* semaphore-post */
BGL_EXPORTED_DEF obj_t BGl_semaphorezd2postzd2zz__pth_semaphorez00(obj_t BgL_sz00_16)
{
{ /* Llib/psemaphore.scm 113 */
{ /* Llib/psemaphore.scm 114 */
 int BgL_arg1069z00_162;
BgL_arg1069z00_162 = 
BGL_SEMAPHORE_POST(BgL_sz00_16); 
return 
BBOOL(
(
(long)(BgL_arg1069z00_162)==0L));} } 

}



/* &semaphore-post */
obj_t BGl_z62semaphorezd2postzb0zz__pth_semaphorez00(obj_t BgL_envz00_174, obj_t BgL_sz00_175)
{
{ /* Llib/psemaphore.scm 113 */
{ /* Llib/psemaphore.scm 114 */
 obj_t BgL_auxz00_604;
if(
BGL_SEMAPHOREP(BgL_sz00_175))
{ /* Llib/psemaphore.scm 114 */
BgL_auxz00_604 = BgL_sz00_175
; }  else 
{ 
 obj_t BgL_auxz00_607;
BgL_auxz00_607 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1107z00zz__pth_semaphorez00, 
BINT(5234L), BGl_string1123z00zz__pth_semaphorez00, BGl_string1118z00zz__pth_semaphorez00, BgL_sz00_175); 
FAILURE(BgL_auxz00_607,BFALSE,BFALSE);} 
return 
BGl_semaphorezd2postzd2zz__pth_semaphorez00(BgL_auxz00_604);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__pth_semaphorez00(void)
{
{ /* Llib/psemaphore.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__pth_semaphorez00(void)
{
{ /* Llib/psemaphore.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__pth_semaphorez00(void)
{
{ /* Llib/psemaphore.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
